<?php
/**
*
* @package Forum Viewer v.0.0.2
* @version $Id: functions_forum_viewer.php 2356 2010-12-23 18:26:32Z 4seven $
* @copyright (c) 2010 / 4seven
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

	// sql construct
	$sql2 = 'SELECT sum(session_viewonline), forum_id, forum_name, GROUP_CONCAT(username) as username
		FROM ' . SESSIONS_TABLE . ' s, ' . FORUMS_TABLE . ' f, ' . USERS_TABLE  . ' u
		WHERE ' . $db->sql_in_set('session_forum_id', $forum_cnt) . '
		AND session_user_id = user_id
		AND session_forum_id = forum_id	
		AND session_forum_id != 0
		AND session_time > ' . (time() - ($config['load_online_time']*60)) . ' 
		AND forum_type = 1
		GROUP BY forum_id';
	$result2 = $db->sql_query($sql2);

	// flip array
	$forum_cnt = array_flip($forum_cnt);

	while ($row2 = $db->sql_fetchrow($result2)){

	// index for template change
	$rownb = $forum_cnt[$row2['forum_id']];

	// remove commas
	$row2['username'] = str_replace(',', ' ', $row2['username']);

	// pre-sort guest count
	$row2_user_base = str_replace('Anonymous',$user->lang['GUEST'], $row2['username']);

	// remove guests from user display
	$row2_username = str_replace($user->lang['GUEST'], '', $row2_user_base);

	// clean  bots a bit
	$row2_username = str_replace(' [Bot]', '[Bot]', $row2_username);

	// guest count
	$row2_guests = substr_count($row2_user_base, $user->lang['GUEST']);

	//guest or guests
    if     ($row2_guests > 1){
	$row2_guests_lang = $user->lang['GUESTS'];}
	else if($row2_guests == 1){	
	$row2_guests_lang = $user->lang['GUEST'];}
	else if($row2_guests == 0){ 
	$row2_guests_lang = '';}	

	// for evtl. later usement
	$row2_comma = ' ' ;

	// build template scheme
	$template->alter_block_array('forumrow', array(
				 'FV_SUM_USER'   => $row2['sum(session_viewonline)'],
                 'FV_USER_SUM'   => ($row2_guests !== 0) ? $row2_username . $row2_comma . $row2_guests . ' ' . $row2_guests_lang : $row2_username,
				 'FV_GUEST_OR_S' => ($row2_guests >= 2 or ($row2['sum(session_viewonline)'] >= 2)) ? true : false), $rownb, 'change');
	
	// transform guest count	
	$rows2_u_rerkon[] = $row2_guests;
	// transform usernames
	$rows2_username[] = $row2_username;
	// transform total count
	$total_session[]  = $row2['sum(session_viewonline)'];
	
	                                            }

	$db->sql_freeresult($result2);

	// only if present
	if (isset($rows2_username)){

	$array_sum_rerkon = array_sum($rows2_u_rerkon);

	foreach ($rows2_username as $rows_username){

			$template->assign_block_vars('rows_username', array(
				'FV_INDEX_UN'	=> $rows_username . ' ',
				'S_FV_INDEX_UN'	=> (sizeof($rows_username) == 0) ? true : false));
                                           }

	if (isset($total_session)){	
			$template->assign_vars(array(
				'FV_TOTAL_FV'	=> array_sum($total_session),	 
	            'FV_TOTAL_VF'	=> sizeof($total_session),
			    'FV_NUM_GUESTS'	=> ($array_sum_rerkon > 1) ? $array_sum_rerkon . ' ' . $user->lang['GUESTS'] : $array_sum_rerkon . ' ' . $user->lang['GUEST'],	
				'S_FV_NO_GUEST'	=> ($array_sum_rerkon == 0) ? true : false));
				          }

	}

?>